<template>
  <h2>Создание категории</h2>
  <form class="form" @submit.prevent>
    <div class="form__body">
      <my-input
          class="input"
          v-model="category.value"
          type="text"
          name="title"
          placeholder="Название категории"
      />
    </div>

    <div v-if="categoryForEdit">
      <input type="hidden" name="id" value="{{ categoryForEdit.id }}">
      <input type="hidden" name="parent_id" value="{{ categoryForEdit.parentId }}">
    </div>

    <div class="form__footer">
      <my-button
          v-if="!editing"
          class="btn"
          @click="createCategory"
      >
        Создать
      </my-button>
      <my-button
          v-if="editing"
          class="btn"
          @click="editCategory"
      >
        Обновить
      </my-button>
    </div>
  </form>
</template>

<script>
export default {
  components: {},
  emits: ['createCategory', 'editCategory'],
  methods: {
    createCategory() {
      this.$emit('createCategory', this.category.value)
      this.category.value = ''
    },
    editCategory() {
      const editedCategory = {...this.$props.categoryForEdit}
      editedCategory.value = this.category.value
      this.$emit('editCategory', editedCategory)
      this.category.value = ''
    }
  },
  props: {
    editing: {
      type: Boolean,
      required: false,
    },
    categoryForEdit: {
      type: Object,
      required: false,
    }
  },
  data(props) {
    return {
      category: {
        value: props.categoryForEdit ? props.categoryForEdit.value : '',
      },
    }
  },
}
</script>

<style scoped>
.form {
  min-width: 400px;
  min-height: 300px;
  display: flex;
  flex-direction: column;
  justify-content: space-between;
}
.form__body {

}
.form__footer {
  align-self: end;
}
</style>